function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import "core-js/modules/es.array.concat.js";
import "core-js/modules/es.error.cause.js";
import "core-js/modules/es.symbol.to-primitive.js";
import "core-js/modules/es.date.to-primitive.js";
import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/es.number.constructor.js";
import "core-js/modules/es.object.keys.js";
import "core-js/modules/es.array.filter.js";
import "core-js/modules/es.object.get-own-property-descriptor.js";
import "core-js/modules/es.array.push.js";
import "core-js/modules/web.dom-collections.for-each.js";
import "core-js/modules/es.object.get-own-property-descriptors.js";
import "core-js/modules/es.symbol.iterator.js";
import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/web.dom-collections.iterator.js";
import React from 'react';
import styled from 'styled-components';
import PropTypes from 'prop-types';
import { Transition } from 'react-transition-group';
import { color, width, height, compose } from 'styled-system';
import { themeGet } from '@styled-system/theme-get';
import { DialogOverlay, DialogContent } from '@reach/dialog';
import { Box, CloseButton, deprecatedColorValue, Flex } from 'pcln-design-system';
var OVERLAY_ANIMATION = function OVERLAY_ANIMATION(transitionState) {
  return "\n  opacity: 0;\n  transition: opacity .5s cubic-bezier(0.50, 0.00, 0.25, 1.00);\n  ".concat(transitionState === 'entering' ? "opacity: 0;" : '', "\n  ").concat(transitionState === 'entered' ? "opacity: 1;" : '', "\n  ").concat(transitionState === 'exiting' ? "opacity: 0;" : '', "\n  ").concat(transitionState === 'exited' ? "opacity: 0;" : '', "\n");
};
var DIALOG_ANIMATION = function DIALOG_ANIMATION(transitionState) {
  return "\n  transform: scale(0.5);\n  transition: transform .5s cubic-bezier(0.50, 0.00, 0.25, 1.00);\n  ".concat(transitionState === 'entering' ? "transform: scale(0.5);" : '', "\n  ").concat(transitionState === 'entered' ? "transform: scale(1);" : '', "\n  ").concat(transitionState === 'exiting' ? "transform: scale(0.5);" : '', "\n  ").concat(transitionState === 'exited' ? "transform: scale(0.5);" : '', "\n");
};
var getAnimation = function getAnimation(_ref) {
  var transitionstate = _ref.transitionstate,
    defaultAnimation = _ref.defaultAnimation,
    _ref$customAnimation = _ref.customAnimation,
    customAnimation = _ref$customAnimation === void 0 ? null : _ref$customAnimation;
  return typeof customAnimation === 'function' ? customAnimation(transitionstate) : defaultAnimation(transitionstate);
};
var Overlay = styled(DialogOverlay).withConfig({
  displayName: "Modal__Overlay",
  componentId: "sc-rzof3m-0"
})(["background-color:rgba(0,0,0,0.7);bottom:0;left:0;overflow-y:auto;position:fixed;right:0;top:0;", " *{box-sizing:border-box;}", ";"], function (props) {
  var _props$theme$lineHeig, _props$theme$fontWeig;
  return "\n    z-index: ".concat(props.zindex || 100, ";\n    font-family: ").concat(props.theme.font, ";\n    line-height: ").concat((_props$theme$lineHeig = props.theme.lineHeights) === null || _props$theme$lineHeig === void 0 ? void 0 : _props$theme$lineHeig.standard, ";\n    font-weight: ").concat((_props$theme$fontWeig = props.theme.fontWeights) === null || _props$theme$fontWeig === void 0 ? void 0 : _props$theme$fontWeig.medium, ";\n  ");
}, getAnimation);
var Dialog = styled(DialogContent).withConfig({
  displayName: "Modal__Dialog",
  componentId: "sc-rzof3m-1"
})(["position:relative;margin-left:auto;margin-right:auto;box-shadow:", ";border-radius:", ";&:focus{outline:none;}", " ", " ", " ", ""], function (props) {
  return props.theme.shadows['overlay-xl'];
}, function (_ref2) {
  var borderRadius = _ref2.borderRadius;
  return themeGet("borderRadii.".concat(borderRadius));
}, function (props) {
  return !props.fullScreen ? "\n    max-height: 100vh;\n    max-width: calc(100vw - 32px);\n  " : "\n    width: 100vw;\n    height: 100vh;\n  ";
}, function (props) {
  return props.enableoverflow && "\n    max-height: none;\n  ";
}, getAnimation, function (props) {
  return compose(color, width, height)(props);
});
var HeaderWrapper = styled.div.withConfig({
  displayName: "Modal__HeaderWrapper",
  componentId: "sc-rzof3m-2"
})(["flex-shrink:0;"]);
var FloatCloseButton = styled(CloseButton).withConfig({
  displayName: "Modal__FloatCloseButton",
  componentId: "sc-rzof3m-3"
})(["position:absolute;top:16px;right:16px;z-index:2;svg{vertical-align:top;}&:focus{background-color:", ";outline:none;}"], function (props) {
  return props.theme.colors.borderGray;
});
var ContentWrapper = styled(Box).withConfig({
  displayName: "Modal__ContentWrapper",
  componentId: "sc-rzof3m-4"
})(["position:relative;", ""], function (props) {
  if (!props.enableoverflow) {
    return "\n        overflow-y: auto;\n        overflow-x: hidden;\n        height: 100%;\n        -webkit-overflow-scrolling: touch;\n      ";
  }
});
var OverlayWrapper = styled.div.withConfig({
  displayName: "Modal__OverlayWrapper",
  componentId: "sc-rzof3m-5"
})(["display:table;height:100%;width:100%;"]);
var DialogWrapper = styled(Box).withConfig({
  displayName: "Modal__DialogWrapper",
  componentId: "sc-rzof3m-6"
})(["display:table-cell;vertical-align:", ";position:relative;height:100%;", ";"], function (_ref3) {
  var verticalAlignment = _ref3.verticalAlignment;
  return verticalAlignment;
}, function (props) {
  return props.enableoverflow && "\n    padding-top: 24px;\n    padding-bottom: 24px;\n  ";
});
var DialogInnerWrapper = styled(Flex).withConfig({
  displayName: "Modal__DialogInnerWrapper",
  componentId: "sc-rzof3m-7"
})(["position:relative;height:100%;"]);
var Modal = function Modal(_ref4) {
  var ariaLabel = _ref4.ariaLabel,
    ariaLabelledBy = _ref4.ariaLabelledBy,
    bg = _ref4.bg,
    borderRadius = _ref4.borderRadius,
    children = _ref4.children,
    className = _ref4.className,
    dialogAnimation = _ref4.dialogAnimation,
    disableCloseButton = _ref4.disableCloseButton,
    enableOverflow = _ref4.enableOverflow,
    fullScreen = _ref4.fullScreen,
    header = _ref4.header,
    height = _ref4.height,
    imgMode = _ref4.imgMode,
    isOpen = _ref4.isOpen,
    onClose = _ref4.onClose,
    overlayAnimation = _ref4.overlayAnimation,
    timeout = _ref4.timeout,
    verticalAlignment = _ref4.verticalAlignment,
    width = _ref4.width,
    zIndex = _ref4.zIndex;
  var dialogHeight = height;
  if (enableOverflow) {
    dialogHeight = null;
  } else if (fullScreen) {
    dialogHeight = '100vh';
  }
  return /*#__PURE__*/React.createElement(Transition, {
    in: isOpen,
    unmountOnExit: true,
    timeout: timeout
  }, function (state) {
    return /*#__PURE__*/React.createElement(Overlay, {
      onDismiss: onClose,
      zindex: zIndex,
      transitionstate: state,
      initialFocusRef: null,
      defaultAnimation: OVERLAY_ANIMATION,
      customAnimation: overlayAnimation
    }, /*#__PURE__*/React.createElement(OverlayWrapper, null, /*#__PURE__*/React.createElement(DialogWrapper, {
      enableoverflow: enableOverflow,
      verticalAlignment: verticalAlignment
    }, /*#__PURE__*/React.createElement(Dialog, {
      width: fullScreen ? '100vw' : width,
      bg: bg,
      borderRadius: borderRadius,
      height: dialogHeight,
      transitionstate: state,
      className: className,
      enableoverflow: enableOverflow ? 'true' : null,
      defaultAnimation: DIALOG_ANIMATION,
      customAnimation: dialogAnimation,
      fullScreen: fullScreen,
      "data-testid": "dialog-content",
      "aria-label": ariaLabel,
      "aria-labelledby": ariaLabelledBy
    }, /*#__PURE__*/React.createElement(DialogInnerWrapper, {
      flexDirection: "column"
    }, header && /*#__PURE__*/React.createElement(HeaderWrapper, null, header), /*#__PURE__*/React.createElement(ContentWrapper, {
      borderRadius: borderRadius,
      p: imgMode ? 0 : 16,
      header: header,
      enableoverflow: enableOverflow
    }, enableOverflow && !disableCloseButton && /*#__PURE__*/React.createElement(FloatCloseButton, {
      "data-testid": "pcln-modal-close",
      header: header,
      onClick: onClose
    }), children))))));
  });
};
Modal.defaultProps = {
  bg: 'white',
  borderRadius: 'xl',
  dialogAnimation: null,
  disableCloseButton: false,
  enableOverflow: false,
  header: null,
  height: 420,
  isOpen: false,
  overlayAnimation: null,
  timeout: 500,
  verticalAlignment: 'middle'
};
var validateAriaProps = function validateAriaProps(props, propName, componentName) {
  if (!props.ariaLabel && !props.ariaLabelledBy) {
    return new Error("A <".concat(componentName, "> must have either an 'ariaLabel' or 'ariaLabelledBy' prop."));
  }
};
Modal.propTypes = _objectSpread(_objectSpread(_objectSpread({}, width.propTypes), height.propTypes), {}, {
  ariaLabel: validateAriaProps,
  ariaLabelledBy: validateAriaProps,
  bg: deprecatedColorValue(),
  className: PropTypes.string,
  dialogAnimation: PropTypes.func,
  disableCloseButton: PropTypes.bool,
  enableOverflow: PropTypes.bool,
  fullScreen: PropTypes.bool,
  header: PropTypes.any,
  headerBg: PropTypes.string,
  imgMode: PropTypes.bool,
  isOpen: PropTypes.bool,
  onClose: PropTypes.func,
  overlayAnimation: PropTypes.func,
  timeout: PropTypes.number,
  title: PropTypes.string,
  verticalAlignment: PropTypes.string,
  zIndex: PropTypes.number
});
export default Modal;