import "core-js/modules/es.array.iterator.js";
import "core-js/modules/es.object.to-string.js";
import "core-js/modules/web.dom-collections.iterator.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.symbol.iterator.js";
import "core-js/modules/es.string.iterator.js";
import "core-js/modules/es.array.push.js";
import "core-js/modules/es.array.slice.js";
import "core-js/modules/es.regexp.to-string.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.array.from.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.regexp.test.js";
import "core-js/modules/es.error.cause.js";
import "core-js/modules/es.object.assign.js";
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { action } from '@storybook/addon-actions';
import { Box, Button, Accordion, Text } from 'pcln-design-system';
import { Menu, MenuItem } from 'pcln-menu';
import React, { useState, useRef } from 'react';
import styled from 'styled-components';
import { Modal, ModalHeader, ScrollLock, SmallModalHeader } from '../src';
import { currencies } from './mockData';
var StyledModal = styled(Modal).withConfig({
  displayName: "Modalstories__StyledModal",
  componentId: "sc-14z4vs9-0"
})(["height:", ";"], function (props) {
  return props.height;
});
var CUSTOM_ANIMATION = function CUSTOM_ANIMATION(transitionState) {
  return "\n  transform: translateY(-122%);\n  transition: transform 0.3s linear;\n  ".concat(transitionState === 'entered' ? "transform: translateY(0%);" : '', "\n");
};
function ModalStory(props) {
  var _useState = useState(props.isOpen),
    _useState2 = _slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setIsOpen = _useState2[1];
  var scrollLock = useRef(new ScrollLock());
  function onClose() {
    setIsOpen(false);
    if (props.lock) {
      scrollLock.current.off();
    }
  }
  return /*#__PURE__*/React.createElement("div", {
    style: {
      height: '1500px'
    }
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick() {
      if (props.lock) {
        scrollLock.current.on();
      }
      setIsOpen(true);
    }
  }, "Open"), /*#__PURE__*/React.createElement(StyledModal, _extends({
    ariaLabel: "Storybook modal.",
    isOpen: isOpen,
    onClose: onClose
  }, props), /*#__PURE__*/React.createElement("div", {
    style: {
      height: '1000px'
    }
  }, "Content with 1000px height")));
}
export default {
  title: 'pcln-modal/Modal',
  component: Modal
};
export var Raw = function Raw() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    width: ['100px', '200px', '500px'],
    disableCloseButton: true
  });
};
export var WithSmallModalHeader = function WithSmallModalHeader() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
    width: ['80vw', '400px', '500px']
  });
};
export var WithModalHeader = function WithModalHeader() {
  // Generate content to demonstrate a scrollable <body>
  var contentLines = _toConsumableArray(Array(100).keys());
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h1", null, "Scroll down to open modal"), contentLines.map(function (i, idx) {
    return /*#__PURE__*/React.createElement("div", {
      key: idx
    }, "Line ", idx);
  }), /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(ModalHeader, {
      title: "Modal title",
      onClose: action('Modal closed!')
    }),
    height: ['90vh', '460px', '560px'],
    width: ['80vw', '400px', '500px']
  }));
};
export var WithSmallModalHeaderAndWhiteBackgroundModalHeaderWithSetTextStyle = function WithSmallModalHeaderAndWhiteBackgroundModalHeaderWithSetTextStyle() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(SmallModalHeader, {
      bg: null,
      color: "primary.base"
    }), /*#__PURE__*/React.createElement(ModalHeader, {
      bg: null,
      color: "background.lightest",
      onClose: action('Modal closed!'),
      pt: 2,
      textStyle: "heading4",
      title: "Modal title"
    })),
    height: ['90vh', '460px', '560px'],
    width: ['80vw', '400px', '500px']
  });
};
export var WithOverflow = function WithOverflow() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
    width: ['80vw', '400px', '500px'],
    enableOverflow: true
  });
};
var accordionItems = [{
  headerLabel: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Text, null, "Header Label First Item")),
  content: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Text, null, "I am some content"), /*#__PURE__*/React.createElement(Text, null, "I am some content"), /*#__PURE__*/React.createElement(Text, null, "I am some content")),
  value: 'item-1'
}];
export var WithOverflowForElementsRenderedInsideTheModal = function WithOverflowForElementsRenderedInsideTheModal() {
  return /*#__PURE__*/React.createElement(StyledModal, {
    ariaLabel: "Storybook modal.",
    isOpen: true,
    height: "100px",
    enableOverflow: true
  }, /*#__PURE__*/React.createElement(Accordion, {
    items: accordionItems
  }));
};
export var WithOverflowAndDropdown = function WithOverflowAndDropdown() {
  return /*#__PURE__*/React.createElement(StyledModal, {
    ariaLabel: "Storybook modal.",
    isOpen: true,
    header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
    height: "100px"
  }, /*#__PURE__*/React.createElement(Menu, {
    idx: "currency-selector",
    buttonNode: /*#__PURE__*/React.createElement("div", null, "open"),
    size: "twoColumns"
  }, currencies.map(function (currency, index) {
    var selected = 'USD' === currency.code;
    return /*#__PURE__*/React.createElement(MenuItem, {
      key: index,
      selected: selected
    }, /*#__PURE__*/React.createElement(Text, {
      regular: true,
      width: 32,
      textAlign: "center",
      mr: 3
    }, currency.symbol), /*#__PURE__*/React.createElement(Text, {
      regular: true
    }, currency.label));
  })));
};
export var WithOverflowAndTallContent = function WithOverflowAndTallContent() {
  return /*#__PURE__*/React.createElement(StyledModal, {
    ariaLabel: "Storybook modal.",
    isOpen: true,
    header: /*#__PURE__*/React.createElement(ModalHeader, {
      onClose: action('Modal closed!')
    }),
    height: "100px",
    enableOverflow: true,
    disableCloseButton: true
  }, /*#__PURE__*/React.createElement(Box, {
    color: "primary",
    height: "500px"
  }, "Priceline"));
};
export var WithImagemodeAndColorful = function WithImagemodeAndColorful() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    bg: "orange",
    header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
    width: ['100px', '200px', '500px'],
    imgMode: true,
    disableCloseButton: true
  });
};
export var RoundedModalWithHeader = function RoundedModalWithHeader() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    bg: "orange",
    header: /*#__PURE__*/React.createElement(ModalHeader, {
      title: "Priceline"
    }),
    width: ['100px', '200px', '500px'],
    imgMode: true,
    disableCloseButton: true
  });
};
export var WithCustomAnimation = function WithCustomAnimation() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
    width: ['100px', '200px', '500px'],
    dialogAnimation: CUSTOM_ANIMATION,
    verticalAlignment: "top"
  });
};
export var ZeroTimeout = function ZeroTimeout() {
  return /*#__PURE__*/React.createElement(ModalStory, {
    disableCloseButton: true,
    width: ['100px', '200px', '500px'],
    timeout: 0
  });
};